"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactModal = _interopRequireDefault(require("react-modal"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Modal = _interopRequireDefault(require("../../styles/cspace-layout/Modal.css"));
var _ModalFooterButton = _interopRequireDefault(require("../../styles/cspace-layout/ModalFooterButton.css"));
var _ModalHeaderButton = _interopRequireDefault(require("../../styles/cspace-layout/ModalHeaderButton.css"));
var _Overlay = _interopRequireDefault(require("../../styles/cspace-layout/Overlay.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } /* global window */
const defaultRenderButtonBar = config => {
  const {
    acceptButtonClassName,
    acceptButtonDisabled,
    acceptButtonLabel,
    cancelButtonClassName,
    cancelButtonDisabled,
    cancelButtonLabel,
    showAcceptButton,
    showCancelButton,
    onAcceptButtonClick,
    onCancelButtonClick
  } = config;
  let acceptButton;
  if (showAcceptButton) {
    acceptButton = /*#__PURE__*/_react.default.createElement("button", {
      className: (0, _classnames.default)(acceptButtonClassName, _ModalFooterButton.default.common),
      disabled: acceptButtonDisabled,
      name: "accept",
      type: "button",
      onClick: onAcceptButtonClick
    }, acceptButtonLabel);
  }
  let cancelButton;
  if (showCancelButton) {
    cancelButton = /*#__PURE__*/_react.default.createElement("button", {
      className: (0, _classnames.default)(cancelButtonClassName, _ModalFooterButton.default.common),
      disabled: cancelButtonDisabled,
      name: "cancel",
      type: "button",
      onClick: onCancelButtonClick
    }, cancelButtonLabel);
  }
  return /*#__PURE__*/_react.default.createElement("div", null, cancelButton, acceptButton);
};
const defaultRenderCloseButton = config => {
  const {
    closeButtonClassName,
    closeButtonDisabled,
    closeButtonLabel,
    showCloseButton,
    onCloseButtonClick
  } = config;
  if (!showCloseButton) {
    return null;
  }
  return /*#__PURE__*/_react.default.createElement("button", {
    className: (0, _classnames.default)(closeButtonClassName, _ModalHeaderButton.default.common),
    disabled: closeButtonDisabled,
    name: "close",
    type: "button",
    onClick: onCloseButtonClick
  }, closeButtonLabel);
};
const propTypes = {
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  contentLabel: _propTypes.default.string,
  isOpen: _propTypes.default.bool,
  title: _propTypes.default.node,
  acceptButtonClassName: _propTypes.default.string,
  acceptButtonDisabled: _propTypes.default.bool,
  acceptButtonLabel: _propTypes.default.string,
  cancelButtonClassName: _propTypes.default.string,
  cancelButtonDisabled: _propTypes.default.bool,
  cancelButtonLabel: _propTypes.default.string,
  closeButtonClassName: _propTypes.default.string,
  closeButtonDisabled: _propTypes.default.bool,
  closeButtonLabel: _propTypes.default.string,
  showAcceptButton: _propTypes.default.bool,
  showCancelButton: _propTypes.default.bool,
  showCloseButton: _propTypes.default.bool,
  renderButtonBar: _propTypes.default.func,
  renderCloseButton: _propTypes.default.func,
  onAcceptButtonClick: _propTypes.default.func,
  onCancelButtonClick: _propTypes.default.func,
  onCloseButtonClick: _propTypes.default.func
};
const defaultProps = {
  children: undefined,
  className: undefined,
  contentLabel: 'Modal',
  isOpen: undefined,
  title: undefined,
  acceptButtonClassName: undefined,
  acceptButtonDisabled: undefined,
  acceptButtonLabel: 'OK',
  cancelButtonClassName: undefined,
  cancelButtonDisabled: undefined,
  cancelButtonLabel: 'Cancel',
  closeButtonClassName: undefined,
  closeButtonDisabled: undefined,
  closeButtonLabel: '×',
  showAcceptButton: true,
  showCancelButton: true,
  showCloseButton: true,
  renderButtonBar: defaultRenderButtonBar,
  renderCloseButton: defaultRenderCloseButton,
  onAcceptButtonClick: undefined,
  onCancelButtonClick: undefined,
  onCloseButtonClick: undefined
};
class Modal extends _react.Component {
  constructor() {
    super();
    this.handleAfterOpen = this.handleAfterOpen.bind(this);
    this.handleBodyRef = this.handleBodyRef.bind(this);
    this.handleFooterRef = this.handleFooterRef.bind(this);
    this.handleHeaderRef = this.handleHeaderRef.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
  }
  handleAfterOpen() {
    // Focus the first input in the body, the first button in the footer, or the first button in the
    // header.

    window.setTimeout(() => {
      let element;
      if (this.bodyDomNode) {
        element = this.bodyDomNode.querySelector('input:not(:disabled)');
      }
      if (!element && this.footerDomNode) {
        element = this.footerDomNode.querySelector('button');
      }
      if (!element && this.headerDomNode) {
        element = this.headerDomNode.querySelector('button');
      }
      if (element) {
        element.focus();
      }
    }, 0);
  }
  handleBodyRef(ref) {
    this.bodyDomNode = ref;
  }
  handleFooterRef(ref) {
    this.footerDomNode = ref;
  }
  handleHeaderRef(ref) {
    this.headerDomNode = ref;
  }
  handleKeyDown(event) {
    if (event.key === 'Escape') {
      // TODO: Make a different callback?

      const {
        closeButtonDisabled,
        onCloseButtonClick
      } = this.props;
      if (!closeButtonDisabled && onCloseButtonClick) {
        onCloseButtonClick(event);
      }
    }
  }
  render() {
    const {
      children,
      className,
      contentLabel,
      isOpen,
      title,
      renderButtonBar,
      renderCloseButton,
      acceptButtonClassName,
      acceptButtonDisabled,
      acceptButtonLabel,
      cancelButtonClassName,
      cancelButtonDisabled,
      cancelButtonLabel,
      closeButtonClassName,
      closeButtonDisabled,
      closeButtonLabel,
      showAcceptButton,
      showCancelButton,
      showCloseButton,
      onAcceptButtonClick,
      onCancelButtonClick,
      onCloseButtonClick,
      ...remainingProps
    } = this.props;
    const closeButton = renderCloseButton({
      closeButtonClassName,
      closeButtonDisabled,
      closeButtonLabel,
      showCloseButton,
      onCloseButtonClick
    });
    const buttonBar = renderButtonBar({
      acceptButtonClassName,
      acceptButtonDisabled,
      acceptButtonLabel,
      cancelButtonClassName,
      cancelButtonDisabled,
      cancelButtonLabel,
      showAcceptButton,
      showCancelButton,
      onAcceptButtonClick,
      onCancelButtonClick
    });
    const footer = buttonBar ? /*#__PURE__*/_react.default.createElement("footer", {
      ref: this.handleFooterRef
    }, buttonBar) : null;
    return /*#__PURE__*/_react.default.createElement(_reactModal.default
    // eslint-disable-next-line react/jsx-props-no-spreading
    , _extends({}, remainingProps, {
      contentLabel: contentLabel,
      isOpen: isOpen,
      className: _Modal.default.common,
      overlayClassName: _Overlay.default.common,
      portalClassName: className,
      onAfterOpen: this.handleAfterOpen
    }), /*#__PURE__*/_react.default.createElement("div", {
      role: "presentation",
      onKeyDown: this.handleKeyDown
    }, /*#__PURE__*/_react.default.createElement("header", {
      ref: this.handleHeaderRef
    }, /*#__PURE__*/_react.default.createElement("div", null, title), closeButton), /*#__PURE__*/_react.default.createElement("div", {
      ref: this.handleBodyRef
    }, children), footer));
  }
}
exports.default = Modal;
Modal.propTypes = propTypes;
Modal.defaultProps = defaultProps;
Modal.setAppElement = element => _reactModal.default.setAppElement(element);