"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _classnames = _interopRequireDefault(require("classnames"));
var _Panel = _interopRequireDefault(require("../../styles/cspace-layout/Panel.css"));
var _PanelButtonBar = _interopRequireDefault(require("../../styles/cspace-layout/PanelButtonBar.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const propTypes = {
  buttons: _propTypes.default.arrayOf(_propTypes.default.node),
  children: _propTypes.default.node,
  className: _propTypes.default.string,
  collapsible: _propTypes.default.bool,
  collapsed: _propTypes.default.bool,
  color: _propTypes.default.string,
  header: _propTypes.default.node,
  name: _propTypes.default.string,
  onToggleCollapsed: _propTypes.default.func
};
const defaultProps = {
  buttons: undefined,
  children: undefined,
  className: undefined,
  collapsible: false,
  collapsed: false,
  color: 'black',
  header: undefined,
  name: undefined,
  onToggleCollapsed: undefined
};
class Panel extends _react.Component {
  constructor(props) {
    super(props);
    this.handleHeaderClick = this.handleHeaderClick.bind(this);
  }
  handleHeaderClick() {
    const {
      collapsible,
      collapsed,
      name,
      onToggleCollapsed
    } = this.props;
    if (collapsible && onToggleCollapsed) {
      onToggleCollapsed(name, !collapsed);
    }
  }
  renderHeader() {
    const {
      buttons,
      collapsible,
      header
    } = this.props;
    if (!header) {
      return null;
    }
    const content = collapsible ? /*#__PURE__*/_react.default.createElement("button", {
      type: "button",
      onClick: this.handleHeaderClick
    }, header) : /*#__PURE__*/_react.default.createElement("div", null, header);
    let buttonBar = null;
    if (buttons && buttons.length > 0) {
      buttonBar = /*#__PURE__*/_react.default.createElement("div", {
        className: _PanelButtonBar.default.common
      }, buttons);
    }
    return /*#__PURE__*/_react.default.createElement("header", null, content, buttonBar);
  }
  renderBody() {
    const {
      collapsible,
      collapsed,
      children
    } = this.props;
    if (collapsible && collapsed) {
      return null;
    }
    return /*#__PURE__*/_react.default.createElement("div", null, children);
  }
  render() {
    const header = this.renderHeader();
    const body = this.renderBody();
    const {
      className,
      collapsible,
      collapsed,
      color
    } = this.props;
    const classes = (0, _classnames.default)(className, _Panel.default.common, _Panel.default[color], collapsible && collapsed ? _Panel.default.collapsed : '');
    return /*#__PURE__*/_react.default.createElement("section", {
      className: classes
    }, header, body);
  }
}
exports.default = Panel;
Panel.propTypes = propTypes;
Panel.defaultProps = defaultProps;