"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _Popup = _interopRequireDefault(require("../../styles/cspace-layout/Popup.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const propTypes = {
  children: _propTypes.default.node,
  tabIndex: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  onMouseLeave: _propTypes.default.func,
  /**
   * Callback to be executed after the Popup has mounted.
   */
  onMount: _propTypes.default.func
};
const defaultProps = {
  children: undefined,
  tabIndex: '-1',
  onBlur: undefined,
  onKeyDown: undefined,
  onMouseLeave: undefined,
  onMount: undefined
};
class Popup extends _react.Component {
  constructor() {
    super();
    this.handleBlur = this.handleBlur.bind(this);
    this.handleKeyDown = this.handleKeyDown.bind(this);
    this.handleRef = this.handleRef.bind(this);
  }
  componentDidMount() {
    const {
      onMount
    } = this.props;
    if (onMount) {
      onMount();
    }
  }
  handleBlur(event) {
    const {
      onBlur
    } = this.props;
    if (onBlur) {
      onBlur(event);
    }
  }
  handleKeyDown(event) {
    const {
      onKeyDown
    } = this.props;
    if (onKeyDown) {
      onKeyDown(event);
    }
  }
  handleRef(ref) {
    this.domNode = ref;
  }
  focus() {
    if (this.domNode) {
      this.domNode.focus();
    }
  }
  render() {
    const {
      children,
      tabIndex,
      onMouseLeave
    } = this.props;
    return /*#__PURE__*/_react.default.createElement("div", {
      className: _Popup.default.common,
      ref: this.handleRef,
      role: "presentation",
      tabIndex: tabIndex,
      onBlur: this.handleBlur,
      onKeyDown: this.handleKeyDown,
      onMouseLeave: onMouseLeave
    }, children);
  }
}
exports.default = Popup;
Popup.propTypes = propTypes;
Popup.defaultProps = defaultProps;