"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _reactVirtualized = require("react-virtualized");
require("!style-loader!css-loader!react-virtualized/styles.css");
var _dimensions = _interopRequireDefault(require("../../styles/dimensions.css"));
var _Table = _interopRequireDefault(require("../../styles/cspace-layout/Table.css"));
var _TableRow = _interopRequireDefault(require("../../styles/cspace-layout/TableRow.css"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); } // eslint-disable-next-line import/no-webpack-loader-syntax, import/no-unresolved
const propTypes = {
  columns: _propTypes.default.arrayOf(_propTypes.default.shape({
    label: _propTypes.default.string,
    dataKey: _propTypes.default.string,
    width: _propTypes.default.number
  })),
  showCheckboxColumn: _propTypes.default.bool,
  renderCheckbox: _propTypes.default.func,
  onRowClick: _propTypes.default.func
};
const defaultProps = {
  columns: [],
  showCheckboxColumn: undefined,
  renderCheckbox: undefined,
  onRowClick: undefined
};
const rowClassName = ({
  index
}) => {
  if (index >= 0) {
    return index % 2 === 0 ? _TableRow.default.even : _TableRow.default.odd;
  }
  return null;
};
const cellRenderer = ({
  cellData
}) => cellData;
class Table extends _react.Component {
  constructor(props) {
    super(props);
    this.handleRowClick = this.handleRowClick.bind(this);
  }
  handleRowClick({
    index
  }) {
    const {
      onRowClick
    } = this.props;
    if (onRowClick) {
      onRowClick(index);
    }
  }
  render() {
    const {
      columns,
      renderCheckbox,
      showCheckboxColumn,
      ...remainingProps
    } = this.props;
    const inputHeight = parseInt(_dimensions.default.inputHeight, 10);
    let checkboxColumn;
    if (showCheckboxColumn) {
      checkboxColumn = /*#__PURE__*/_react.default.createElement(_reactVirtualized.Column, {
        key: "check",
        dataKey: "selected",
        disableSort: true,
        cellRenderer: renderCheckbox,
        width: inputHeight - 2,
        flexGrow: 0,
        flexShrink: 0
      });
    }
    return /*#__PURE__*/_react.default.createElement(_reactVirtualized.AutoSizer, null, ({
      height,
      width
    }) => /*#__PURE__*/_react.default.createElement(_reactVirtualized.Table
    // eslint-disable-next-line react/jsx-props-no-spreading
    , _extends({}, remainingProps, {
      className: _Table.default.common,
      width: width,
      height: height,
      headerHeight: inputHeight,
      rowHeight: inputHeight,
      rowClassName: rowClassName,
      tabIndex: -1,
      onRowClick: this.handleRowClick
    }), checkboxColumn, columns.map(column => /*#__PURE__*/_react.default.createElement(_reactVirtualized.Column, _extends({
      key: column.dataKey,
      cellRenderer: cellRenderer
      // eslint-disable-next-line react/jsx-props-no-spreading
    }, column)))));
  }
}
exports.default = Table;
Table.SortDirection = _reactVirtualized.SortDirection;
Table.defaultRowRenderer = _reactVirtualized.defaultTableRowRenderer;
Table.propTypes = propTypes;
Table.defaultProps = defaultProps;